Description

パス名を扱うFileの特異メソッドで引数のパスのエンコーディングが無視されています。

Related issues:

Related to Ruby - Bug #2154: filesystem encoding of UNIX Rejected

Associated revisions

Revision ed469831 - 01/25/2012 02:32 AM - nobu (Nobuyoshi Nakada)

file.c (rb_enc_path_next, rb_enc_path_skip_prefix)

(rb_enc_path_last_separator, rb_enc_path_end)

(ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware

path handling functions.

file.c (rb_home_dir, file_expand_path, rb_realpath_internal)

(rb_file_s_basename, rb_file_dirname, rb_file_s_extname)

(rb_file_join): should respect the encodings of arguments than

file system encoding.  [ruby-dev:45145] [Bug #5919]

dir.c (check_dirname, ruby_glob0): ditto.

ext/pathname/pathname.c (path_sub_ext): ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@34372 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 42c34dd375c368d8e08f5243571d6983c9d02e19 - 07/03/2012 02:44 AM - naruse (Yui NARUSE)

merge revision(s) 34372:

    * file.c (rb_enc_path_next, rb_enc_path_skip_prefix)

      (rb_enc_path_last_separator, rb_enc_path_end)

      (ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware

      path handling functions.

    * file.c (rb_home_dir, file_expand_path, rb_realpath_internal)

      (rb_file_s_basename, rb_file_dirname, rb_file_s_extname)

      (rb_file_join): should respect the encodings of arguments than

      file system encoding.  [ruby-dev:45145] [Bug #5919]

    * dir.c (check_dirname, ruby_glob0): ditto.

    * ext/pathname/pathname.c (path_sub_ext): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@36279 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 42c34dd3 - 07/03/2012 02:44 AM - naruse (Yui NARUSE)

merge revision(s) 34372:

    * file.c (rb_enc_path_next, rb_enc_path_skip_prefix)

      (rb_enc_path_last_separator, rb_enc_path_end)

      (ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware

      path handling functions.

    * file.c (rb_home_dir, file_expand_path, rb_realpath_internal)

      (rb_file_s_basename, rb_file_dirname, rb_file_s_extname)

      (rb_file_join): should respect the encodings of arguments than

      file system encoding.  [ruby-dev:45145] [Bug #5919]
    * dir.c (check_dirname, ruby_glob0): ditto.

    * ext/pathname/pathname.c (path_sub_ext): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@36279 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0e6dcc7ab24e6e5b8ee3b9a532c0318eb5155e2e - 10/26/2012 03:01 AM - U.Nakamura 

merge revision(s) 32826,34732: [Backport #6681]

file.c (rb_enc_path_next, rb_enc_path_skip_prefix)

(rb_enc_path_last_separator, rb_enc_path_end)

(ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware

path handling functions.

file.c (rb_home_dir, file_expand_path, rb_realpath_internal)

(rb_file_s_basename, rb_file_dirname, rb_file_s_extname)

(rb_file_join): should respect the encodings of arguments than

file system encoding.  [ruby-dev:45145] [Bug #5919]

dir.c (check_dirname, ruby_glob0): ditto.

ext/pathname/pathname.c (path_sub_ext): ditto.

util.c, include/ruby/util.h (ruby_add_suffix): remove the function.

[Bug #5153] [ruby-core:38736]

io.c (argf_next_argv): remove the call of above function.

ext/-test-/add_suffix, test/-ext-/test_add_suffix.rb: remove the test

extension module because this is only for testsing ruby_add_suffix().

LEGAL: remove the mention about a part of util.c, because now we

removed the part.

io.c (argf_next_argv): now the new filename is not guranteed to

use, so should check the return value of rename(2).

test/ruby/test_argf.rb (TestArgf#test_inplace_rename_impossible):

now we expect same result with other platforms on no_safe_rename

platforms (=Windows).

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@37330 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0e6dcc7a - 10/26/2012 03:01 AM - U.Nakamura 

merge revision(s) 32826,34732: [Backport #6681]

file.c (rb_enc_path_next, rb_enc_path_skip_prefix)

(rb_enc_path_last_separator, rb_enc_path_end)

(ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware

path handling functions.

file.c (rb_home_dir, file_expand_path, rb_realpath_internal)

(rb_file_s_basename, rb_file_dirname, rb_file_s_extname)

(rb_file_join): should respect the encodings of arguments than

file system encoding.  [ruby-dev:45145] [Bug #5919]

dir.c (check_dirname, ruby_glob0): ditto.

ext/pathname/pathname.c (path_sub_ext): ditto.

util.c, include/ruby/util.h (ruby_add_suffix): remove the function.

[Bug #5153] [ruby-core:38736]

io.c (argf_next_argv): remove the call of above function.

ext/-test-/add_suffix, test/-ext-/test_add_suffix.rb: remove the test

extension module because this is only for testsing ruby_add_suffix().

LEGAL: remove the mention about a part of util.c, because now we

removed the part.
io.c (argf_next_argv): now the new filename is not guranteed to

use, so should check the return value of rename(2).

test/ruby/test_argf.rb (TestArgf#test_inplace_rename_impossible):

now we expect same result with other platforms on no_safe_rename

platforms (=Windows).

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@37330 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/25/2012 11:32 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r34372.

Nobuyoshi, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

file.c (rb_enc_path_next, rb_enc_path_skip_prefix)

(rb_enc_path_last_separator, rb_enc_path_end)

(ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware

path handling functions.

file.c (rb_home_dir, file_expand_path, rb_realpath_internal)

(rb_file_s_basename, rb_file_dirname, rb_file_s_extname)

(rb_file_join): should respect the encodings of arguments than

file system encoding.  [ruby-dev:45145] [Bug #5919]

dir.c (check_dirname, ruby_glob0): ditto.

ext/pathname/pathname.c (path_sub_ext): ditto.

Files

file_encoding.diff 32 KB 01/21/2012 nobu (Nobuyoshi Nakada)
